#include "assets.h"
#include "camera.h"
#include "debug.h"
#include "input.h"
#include "physics_entity.h"
#include "physics_world.h"
#include "program.h"
#include "rigidbody.h"
#include "spritesheet.h"
#include "sprite.h"
#include "tilemap.h"
#include "player.h"
#include <assert.h>

static Player* player = NULL;
static Level* level = NULL;

static
void play() {

    g_camera.fov = 40;

    player = malloc(sizeof(Player));
    player_spawn(player, (Vector){1.25f, 20.f});

    level = level_load("level_0");
}

static
void tick() {
    Player_as_BehaviourEntity(player).tc->update(player, delta_time());
    g_camera.transform.position = player->transform.position;
}

static
void draw() {
    level_draw(level);
    sprite_entity_draw(Player_as_SpriteEntity(player));
}

int main(int argc, char* argv[]) {
    struct ProgramSettings config = {
        .target_fps = 120,
        .title = "fencer",
        .view_resolution = {1920, 1080},
        .on_play = &play,
        .on_tick = &tick,
        .on_draw = &draw
    };
    return program_run(&config);
}
